      INTEGER FUNCTION  SYSOPT (LETTER)
C     (COMMAND OPTION - Unix Version)
C     SEARCH THE RUN-TIME COMMAND LINE FOR AN OPTION LETTER AND
C     POSSIBLE NUMERIC VALUE RETURNING SYSOPT .GE. 0 IF FOUND,
C     AND -1 IF NOT FOUND.  FOR THE DECSYSTEM-20 IMPLEMENTATION,
C     THE COMMAND LINE IS RETRIEVED BY ROUTINE SYSGCL AS A PACKED
C     STRING.  SYSGCL IN TURN CALLS AN ASSEMBLY-LANGUAGE ROUTINE,
C     JRSCAN, WHICH GETS THE RUN-TIME COMMAND LINE, AND THEN IT
C     APPENDS TO THIS THE FIRST 80 CHARACTERS OF A FILE NAMED
C     "PRGNAM.OPT", IF ONE EXISTS, WHERE "PRGNAM" IS THE NAME OF
C     THE PROGRAM BEING RUN.  THIS PERMITS USERS TO MAINTAIN
C     THEIR OWN DEFAULT OPTIONS.
C
C     -L
C
C     OR
C
C     -L:NNN
C
C     WHERE "L" IS A LETTER AND "NNN" IS A STRING OF 1 OR MORE
C     DECIMAL DIGITS. IF THE REQUESTED OPTION IS FOUND, AND A
C     NUMERIC VALUE IS SPECIFIED, THEN SYSOPT = NNN ON RETURN.  IF
C     NO NUMERIC VALUE IS SPECIFIED, THEN SYSOPT = 0 ON RETURN.
C     THUS -L AND -L:0 ARE EQUIVALENT.  THE COMMAND LINE TAKES
C     THE FORM
C
C     @SF3 -A -B -C -D...
C
C     WHERE -A -B -C -D... ARE OPTIONS.  THE TEXT RETURNED IN THE
C     COMMAND LINE HAS THE PROGRAM NAME REMOVED, SO THAT IT
C     APPEARS AS "-A -B -C -D...".
C     (11-AUG-80)
      INTEGER          CMDLIN(30),  COLNRZ,      DASHRZ,      DECVAL
      INTEGER          IARG
      INTEGER          K,           KARASC,      LASTCH,      LENCMD
      INTEGER          LETTCH,      LETTER(1),   MAXCMD,      NEXTCH
      INTEGER          NINERZ,      RESULT,      SLSHRZ,      ZERORZ
      LOGICAL          DECDIG,      DIGIT,       FIRST,       FOUND
      LOGICAL          MORE
      DATA FIRST/.TRUE./, MAXCMD/30/
C
C     LOGICAL STATEMENT FUNCTION RETURNING .TRUE. IF RIGHT-ZERO
C     CHARACTER ARGUMENT IS A DECIMAL DIGIT.
C
      DECDIG(IARG) = (ZERORZ .LE. IARG) .AND. (IARG .LE. NINERZ)
C
C     INTEGER STATEMENT FUNCTION RETURNING INTEGER VALUE OF A
C     CHARACTER WHICH IS KNOWN TO REPRESENT A DIGIT.
C
      DECVAL(IARG) = IARG - ZERORZ
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 IF (.NOT.(LENCMD .GT. 0)) GO TO 20002
      ASSIGN 20005 TO NPR002
      GO TO 30002
20005 GO TO 20003
20002 RESULT = -1
20003 SYSOPT = RESULT
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (INITIALIZE)
30001 IF (FIRST) CALL SYSGCL (CMDLIN,MAXCMD,LENCMD)
      FIRST = .FALSE.
      ZERORZ = KARASC(1H0)
      NINERZ = KARASC(1H9)
      COLNRZ = KARASC(1H:)
      SLSHRZ = KARASC(1H/)
      DASHRZ = KARASC(1H-)
      GO TO NPR001, (20001)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (SEARCH FOR THE OPTION LETTER)
30002 LETTCH = KARASC(KARUC(LETTER))
      K = 0
      LASTCH = 0
      GO TO 20007
20006 IF (FOUND .OR. .NOT.MORE) GO TO 20008
20007 ASSIGN 20009 TO NPR003
      GO TO 30003
20009 FOUND = (NEXTCH .EQ. LETTCH) .AND. (LASTCH .EQ. DASHRZ)
      LASTCH = NEXTCH
      GO TO 20006
20008 IF (.NOT.(FOUND)) GO TO 20010
      ASSIGN 20013 TO NPR004
      GO TO 30004
20013 GO TO 20011
20010 RESULT = -1
20011 GO TO NPR002, (20005)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (EXTRACT NUMERIC VALUE, IF ANY)
30004 ASSIGN 20014 TO NPR003
      GO TO 30003
20014 IF (.NOT.(NEXTCH .EQ. COLNRZ)) GO TO 20015
      RESULT = 0
      GO TO 20019
20018 IF (.NOT.DIGIT) GO TO 20020
20019 ASSIGN 20021 TO NPR003
      GO TO 30003
20021 DIGIT = MORE .AND. DECDIG(NEXTCH)
      IF (DIGIT) RESULT = 10*RESULT + DECVAL(NEXTCH)
      GO TO 20018
20020 GO TO 20016
20015 RESULT = 0
20016 GO TO NPR004, (20013)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (RETRIEVE NEXT CHARACTER AND MAKE UPPER-CASE)
30003 K = K + 1
      CALL KARGET (NEXTCH,CMDLIN,K)
      NEXTCH = KARASC(KARUC(NEXTCH))
      MORE = (K .LE. LENCMD)
      GO TO NPR003, (20009,20014,20021)
C
      END
