      SUBROUTINE  ADDHT (STRING,FIRST,LENSTR,HASHTB,CASEID)
C     (Add String to Hash Table)
C     Given a  substring  of  "LENSTR"  characters  beginning  at
C     position "FIRST" in STRING(*), and identified by an integer
C     "CASEID", add it to the hash table defined by  "HASHTB(*)".
C     If the string already is present in the table, return  will
C     occur immediately.
C     (30-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       F4MVC,       SFTERR,      SRCHHT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      INTEGER             NWDSF
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                HASHTB,      KWORDS,      NULL,        NXFREE
C
      INTEGER             CASEID,      FIRST,       HASHTB(3),   IARG
      INTEGER             ID,          KWORDS,      LENSTR,      LOCHTB
      INTEGER             NULL,        NXFREE,      STRING(1)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM14  /
C
      INTEGER             WDSIZE
C
      COMMON / COM14  /   WDSIZE
C
C
C
C     Element defining a null link  in a list.  Any  non-positive
C     value could be used.
C
      DATA                NULL      / 0 /
C
C
C     Statement function defining number of words in a string  of
C     IARG characters.  This function  is used in ADDHT,  IOFUNC,
C     and OUTSTM, and requires WDSIZE defined in /COM14/.
C
      NWDSF(IARG) = (IARG+WDSIZE-1)/WDSIZE
C
C
      CALL SRCHHT (STRING,FIRST,LENSTR,HASHTB,LOCHTB,ID)
      IF (.NOT.(ID .EQ. NULL)) GO TO 20001
      NXFREE = HASHTB(2)
      KWORDS = NWDSF(LENSTR)
      IF (.NOT.((NXFREE+2+KWORDS) .GT. HASHTB(3))) GO TO 20004
      CALL SFTERR (2,21H(Hash table overflow))
20004 CONTINUE
20005 HASHTB(LOCHTB) = NXFREE
      HASHTB(NXFREE) = NULL
      HASHTB(NXFREE+1) = CASEID
      HASHTB(NXFREE+2) = LENSTR
      CALL F4MVC (STRING,FIRST,HASHTB(NXFREE+3),1,LENSTR)
      HASHTB(2) = NXFREE + 3 + KWORDS
20001 CONTINUE
C
20002 RETURN
      END
